package com.liang.service;

import com.liang.common.utils.*;
import com.liang.entity.SysUserInfo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * (SysUserInfo)表服务接口
 *
 * @author makejava
 * @since 2023-02-19 21:37:39
 */
public interface SysUserInfoService {

    /**
     * 通过ID查询单条数据
     *
     * @param userId 主键
     * @return 实例对象
     */
    SysUserInfo queryById(Integer userId);

    /**
     * 分页查询
     *
     * @param sysUserInfo 筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<SysUserInfo> queryByPage(SysUserInfo sysUserInfo, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param sysUserInfo 实例对象
     * @return 实例对象
     */
    int insert(SysUserInfo sysUserInfo);

    /**
     * 修改数据
     *
     * @param sysUserInfo 实例对象
     * @return 实例对象
     */
    int update(SysUserInfo sysUserInfo);

    /**
     * 通过主键删除数据
     *
     * @param userId 主键
     * @return 是否成功
     */
    boolean deleteById(Integer userId, Integer updateUser);

    /**
     * 获取用户列表
     *
     * @param map
     * @return
     */
    List<SysUserInfo> getSysUserInfoList(Map map);

    /**
     * 获取岗位信息
     * @param map
     * @return
     */

    List<SysUserInfo> getGw(Map map);
    /**
     * 获取用户
     *
     * @param map
     * @return
     */
    SysUserInfo getSysUserInfo(Map map);

    /**
     * 批量删除系统用户
     *
     * @param
     * @return
     */
    int batchDelete(List<Integer> userIdList, Integer updateUser);

    /**
     * 删除一个系统用户
     *
     * @param userId
     * @return
     */
    int delete(Integer userId);

    /**
     * 校验用户账号是否唯一
     *
     * @param account 用户账号
     * @return
     */
    int checkUserNameUnique(String account);

    /**
     * 新增用户
     *
     * @param userInfo
     * @return
     */
    int doAdd(SysUserInfo userInfo);

    /**
     * 用户修改
     *
     * @param userInfo
     * @return
     */
    int doUpdate(SysUserInfo userInfo);

    /**
     * 用户密码重置
     *
     * @param userInfo
     * @return
     */
    int resetPass(SysUserInfo userInfo);

    /**
     * 通过id获取一条记录
     *
     * @param userId
     * @return
     */
    SysUserInfo getOneById(Integer userId);

    /**
     * 获取用户token
     *
     * @return
     */
    String getUserKey();

    /**
     * 获取创建人
     *
     * @return
     */
    List<Map<String, String>> getCJR();

    /**
     * 通过account获取一条记录
     *
     * @param account
     * @return
     */
    SysUserInfo getUserByAccount(String account);

    /**
     * 根据登录信息查询所属部门名称
     *
     * @param dept_id 部门id
     * @return
     */
    String getDeptNameByAccount(String dept_id);

    /**
     * 根据登录id查询岗位名称
     *
     * @param userId
     * @return
     */
    List<String> getPostNameByUserId(Integer userId);



    List<SysUserInfo> getDept(Integer id);

    /**
     * 获取当前人员部门信息
     * @return
     */
    List<SysUserInfo> getDeptName();

    /**
     * 通过主键查询数据
     */
    String getBzs(Integer id);
}
